include <MCAD/triangles.scad>

button_main_dia = 87.5+0.1;
button_tab_dia = 6;
select_button_dia = 24.3;
height = 60;
wall_thickness = 6;
cube_width = 140/2;
cube_length = 130;
cube_erode = 0.05;

$fs = 0.01;
$fn = 100;

module screw() {
    cylinder(d=3.5,h=30);
    cylinder(d1=14,d2=7,h=10);
}

module nut() {
    cylinder(d=3.5,h=30);
    translate([0,0,0]) cylinder(d=6.5+0.2,h=10, $fn=6);
}

module insert() {
    a = 5.1;
    b = 5.31;
    h = 3.8;
    d = 3;
    // hole
    cylinder(d=a, h=h+0.15);
    // ream
    cylinder(d1=b+0.2, d2=a, h=2);
    // screw passage
    cylinder(d=d+0.5, h=20);
}


module button_frame() {
    difference() {
        union() {
            translate([-cube_width/2,-cube_length/2,0]) difference() {
                union() {
                    translate([cube_erode, cube_erode, 0]) cube([cube_width-cube_erode*2,cube_length-cube_erode*2,height]);
                }
                  translate([wall_thickness,wall_thickness,-6]) cube([cube_width-wall_thickness*2,cube_length-wall_thickness*2,height]);
                // door
                translate([2,2,-10]) cube([cube_width-2*2,cube_length-2*2,10+4]);
                //button
                translate([cube_width/2,30,0]) cylinder(d=select_button_dia, h=100);
                translate([cube_width/2,30,0]) cylinder(d=27, h=height-3.5);
                // cable access
                translate([cube_width/2-6,0,0]) cube([12,10,10]);
                translate([cube_width/2+16,0,0]) cube([5,10,10]);
                // screws
                // front
                translate([cube_width*2/4,cube_length-14,15]) rotate([-90,0,0]) nut();
                translate([cube_width*2/4,cube_length-14,45]) rotate([-90,0,0]) nut();
                         //right
                //translate([cube_width-14,cube_length*1/8,15]) rotate([0,90,0]) screw();
                //translate([cube_width-14,cube_length*7/8,15]) rotate([0,90,0]) screw();
                //translate([cube_width-14,cube_length*1/8,45]) rotate([0,90,0]) screw();
                //translate([cube_width-14,cube_length*7/8,45]) rotate([0,90,0]) screw();
                //left
                translate([14,cube_length*1/8,15]) rotate([0,-90,0]) nut();
                translate([14,cube_length*7/8,15]) rotate([0,-90,0]) nut();
                translate([14,cube_length*1/8,45]) rotate([0,-90,0]) nut();
                translate([14,cube_length*7/8,45]) rotate([0,-90,0]) nut();
                
                //translate([-10,70,30]) rotate([0,90,0]) cylinder(d=40, h=160);
                //translate([cube_width/2,200,30]) rotate([90,0,0]) cylinder(d=40, h=160);
                //translate([cube_width/2-25,cube_length/2,10]) cube([50,100,40]);
                //translate([cube_width/2-60,cube_length/2,10]) cube([15,100,40]);
                //translate([cube_width/2+45,cube_length/2,10]) cube([15,100,40]);
                
                translate([-150,cube_length/2-40,10]) cube([200,80,40]);
                // for testing only
                //translate([-50,-50,0]) cube([200,200,height-10]);
            }
            translate([-cube_width/2,cube_length/2-2,0]) rotate([180,0,0]) rotate([0,90,0]) triangle(3,4,cube_width);
            translate([-cube_width/2,cube_length/2-2,4]) rotate([180,0,0]) rotate([0,90,0]) triangle(3,4,cube_width);
            translate([-cube_width/2+4,-62, 4]) cube([8,8,60-4]);  
            translate([cube_width/2-4-8,-62, 4]) cube([8,8,60-4]);
        }
        translate([cube_width/2-4-8+4,-58, 4]) insert();
        translate([-cube_width/2+4+4,-58, 4]) insert();
    }    
}

color("white") translate([140*0,0,0]) button_frame();
/*
color("green") translate([140*1,0,0]) button_frame();
color("red") translate([140*2,0,0]) button_frame();
color("green") translate([140*3,0,0]) button_frame();
color("white") translate([140*4,0,0]) button_frame();

color("yellow") translate([140*0.5,140,0]) scale([1,-1,1])  button_frame();
color("blue") translate([140*1.5,140,0]) scale([1,-1,1])  button_frame();
color("blue") translate([140*2.5,140,0]) scale([1,-1,1])  button_frame();
color("yellow") translate([140*3.5,140,0]) scale([1,-1,1])  button_frame();

color("gray") translate([140*0,140,0]) scale([1,-1,1])  left_end();
color("gray") translate([140*4.5,140,0]) scale([1,-1,1])  left_end();
*/